#!/bin/bash
source ../../global-conf.sh

if ( dpkg -s pwgen >/dev/null 2>&1 ); then
	echo "The pwgen package is already installed."
else
	apt-get install -y -o Dpkg::Options::="--force-confold" pwgen
fi

conf_path="../../auto-generated-conf.sh"

# Autogenerate missing values
if [ "${MS_ID}" = "" ]; then
	MS_ID=$(echo "$(hostname)_msuser")
	if ( cat "$conf_path" | grep "MS_ID" >/dev/null ); then
		sed -i "s@^MS_ID=.*@MS_ID='${MS_ID}'@" "$conf_path"
	else
		echo "MS_ID='${MS_ID}'" >> "$conf_path"
	fi
	echo -e "${YELLOW}The config MS_ID has been set. If you forgot to fill it before, please change the value in the envsetup configuration.${NC}"
	sleep 3
fi
if [ "${MS_API_KEY}" = "" ]; then
	MS_API_KEY=$(echo "s$(pwgen 4)-$(pwgen 5)-$(pwgen 5)-$(pwgen 5)-$(pwgen 5)")
	# respect API pattern
	MS_API_KEY=$(echo $MS_API_KEY | sed "s@[iloILO]@$((${RANDOM} / 10000))@g")
	if ( cat "$conf_path" | grep "MS_API_KEY" >/dev/null ); then
		sed -i "s@^MS_API_KEY=.*@MS_API_KEY='${MS_API_KEY}'@" "$conf_path"
	else
		echo "MS_API_KEY='${MS_API_KEY}'" >> "$conf_path"
	fi
	echo -e "${YELLOW}The config MS_API_KEY has been set. If you forgot to fill it before, please change the value in the envsetup configuration.${NC}"
	sleep 3
fi
if [ "${MS_SECRET}" = "secret" ]; then
	MS_SECRET=$(echo "$(pwgen 40)")
	if ( cat "$conf_path" | grep "MS_SECRET" >/dev/null ); then
		sed -i "s@^MS_SECRET=.*@MS_SECRET='${MS_SECRET}'@" "$conf_path"
	else
		echo "MS_SECRET='${MS_SECRET}'" >> "$conf_path"
	fi
	echo -e "${YELLOW}The config MS_SECRET has been set. If you forgot to fill it before, please change the value in the envsetup configuration.${NC}"
	sleep 3
fi
